VTK: vtkCellGridSidesQuery Class Reference

| VTK 9.3.1

Classes | Public Types | Public Member Functions | Static Public Member Functions | Protected Member Functions | Protected Attributes | List of all members
vtkCellGridSidesQuery Class Reference

A cell-grid query for enumerating sides of cells. More...

`#include <vtkCellGridSidesQuery.h>`

Inheritance diagram for vtkCellGridSidesQuery:
[legend]
Collaboration diagram for vtkCellGridSidesQuery:
[legend]

## Classes
struct | Entry
class | HashCombiner
struct | Side

## Public Types
typedef vtkCellGridQuery | Superclass
Public Types inherited from vtkCellGridQuery
typedef vtkObject | Superclass

## Public Member Functions
virtual vtkTypeBool | IsA (const char *type)
| Return 1 if this class is the same type of (or a subclass of) the named class. More...
vtkCellGridSidesQuery * | NewInstance () const
void | PrintSelf (ostream &os, vtkIndent indent) override
| Methods invoked by print to print information about the object including superclasses. More...
void | Initialize () override
| Override this if your query-result state requires initialization. More...
void | Finalize () override
| Override this if your query-result state requires finalization. More...
std::map< vtkStringToken, std::unordered_map< vtkStringToken, std::unordered_map< vtkIdType, std::set< int > > > > & | GetSides ()
template<typename T , std::size_t NN>
void | AddSide (vtkStringToken cellType, vtkIdType cell, int side, vtkStringToken shape, const std::array< T, NN > &conn)
| Add a side with the given shape and connectivity to the request's state. More...
template<typename T >
void | AddSide (vtkStringToken cellType, vtkIdType cell, int side, vtkStringToken shape, const std::vector< T > &conn)
Public Member Functions inherited from vtkCellGridQuery
vtkCellGridQuery * | NewInstance () const
Public Member Functions inherited from vtkObject
| vtkBaseTypeMacro (vtkObject, vtkObjectBase)
virtual void | DebugOn ()
| Turn debugging output on. More...
virtual void | DebugOff ()
| Turn debugging output off. More...
bool | GetDebug ()
| Get the value of the debug flag. More...
void | SetDebug (bool debugFlag)
| Set the value of the debug flag. More...
virtual void | Modified ()
| Update the modification time for this object. More...
virtual vtkMTimeType | GetMTime ()
| Return this object's modified time. More...
void | RemoveObserver (unsigned long tag)
void | RemoveObservers (unsigned long event)
void | RemoveObservers (const char *event)
void | RemoveAllObservers ()
vtkTypeBool | HasObserver (unsigned long event)
vtkTypeBool | HasObserver (const char *event)
vtkTypeBool | InvokeEvent (unsigned long event)
vtkTypeBool | InvokeEvent (const char *event)
std::string | GetObjectDescription () const override
| The object description printed in messages and PrintSelf output. More...
unsigned long | AddObserver (unsigned long event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
unsigned long | AddObserver (const char *event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkCommand * | GetCommand (unsigned long tag)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObserver (vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObservers (unsigned long event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObservers (const char *event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkTypeBool | HasObserver (unsigned long event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkTypeBool | HasObserver (const char *event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, bool(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Allow user to set the AbortFlagOn() with the return value of the callback method. More...
vtkTypeBool | InvokeEvent (unsigned long event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
vtkTypeBool | InvokeEvent (const char *event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
virtual void | SetObjectName (const std::string &objectName)
| Set/get the name of this object for reporting purposes. More...
virtual std::string | GetObjectName () const
| Set/get the name of this object for reporting purposes. More...
Public Member Functions inherited from vtkObjectBase
const char * | GetClassName () const
| Return the class name as a string. More...
virtual vtkIdType | GetNumberOfGenerationsFromBase (const char *name)
| Given the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
virtual void | Delete ()
| Delete a VTK object. More...
virtual void | FastDelete ()
| Delete a reference to this object. More...
void | InitializeObjectBase ()
void | Print (ostream &os)
| Print an object to an ostream. More...
virtual void | Register (vtkObjectBase *o)
| Increase the reference count (mark as used by another object). More...
virtual void | UnRegister (vtkObjectBase *o)
| Decrease the reference count (release by another object). More...
int | GetReferenceCount ()
| Return the current reference count of this object. More...
void | SetReferenceCount (int)
| Sets the reference count. More...
bool | GetIsInMemkind () const
| A local state flag that remembers whether this object lives in the normal or extended memory space. More...
virtual void | PrintHeader (ostream &os, vtkIndent indent)
| Methods invoked by print to print information about the object including superclasses. More...
virtual void | PrintTrailer (ostream &os, vtkIndent indent)
| Methods invoked by print to print information about the object including superclasses. More...
virtual bool | UsesGarbageCollector () const
| Indicate whether the class uses `vtkGarbageCollector` or not. More...

## Static Public Member Functions
static vtkCellGridSidesQuery * | New ()
static vtkTypeBool | IsTypeOf (const char *type)
static vtkCellGridSidesQuery * | SafeDownCast (vtkObjectBase *o)
Static Public Member Functions inherited from vtkCellGridQuery
static vtkTypeBool | IsTypeOf (const char *type)
static vtkCellGridQuery * | SafeDownCast (vtkObjectBase *o)
Static Public Member Functions inherited from vtkObject
static vtkObject * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | BreakOnError ()
| This method is called when vtkErrorMacro executes. More...
static void | SetGlobalWarningDisplay (vtkTypeBool val)
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOn ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOff ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static vtkTypeBool | GetGlobalWarningDisplay ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
Static Public Member Functions inherited from vtkObjectBase
static vtkTypeBool | IsTypeOf (const char *name)
| Return 1 if this class type is the same type of (or a subclass of) the named class. More...
static vtkIdType | GetNumberOfGenerationsFromBaseType (const char *name)
| Given a the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
static vtkObjectBase * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | SetMemkindDirectory (const char *directoryname)
| The name of a directory, ideally mounted -o dax, to memory map an extended memory space within. More...
static bool | GetUsingMemkind ()
| A global state flag that controls whether vtkObjects are constructed in the usual way (the default) or within the extended memory space. More...

## Protected Member Functions
virtual vtkObjectBase * | NewInstanceInternal () const
| vtkCellGridSidesQuery ()=default
| ~vtkCellGridSidesQuery () override=default
Protected Member Functions inherited from vtkCellGridQuery
| vtkCellGridQuery ()=default
| ~vtkCellGridQuery () override=default
Protected Member Functions inherited from vtkObject
| vtkObject ()
| ~vtkObject () override
void | RegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | UnRegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | InternalGrabFocus (vtkCommand *mouseEvents, vtkCommand *keypressEvents=nullptr)
| These methods allow a command to exclusively grab all events. More...
void | InternalReleaseFocus ()
| These methods allow a command to exclusively grab all events. More...
Protected Member Functions inherited from vtkObjectBase
| vtkObjectBase ()
virtual | ~vtkObjectBase ()
virtual void | ReportReferences (vtkGarbageCollector *)
| vtkObjectBase (const vtkObjectBase &)
void | operator= (const vtkObjectBase &)

## Protected Attributes
std::unordered_map< std::size_t, Entry > | Hashes
std::map< vtkStringToken, std::unordered_map< vtkStringToken, std::unordered_map< vtkIdType, std::set< int > > > > | Sides
Protected Attributes inherited from vtkObject
bool | Debug
vtkTimeStamp | MTime
vtkSubjectHelper * | SubjectHelper
std::string | ObjectName
Protected Attributes inherited from vtkObjectBase
std::atomic< int32_t > | ReferenceCount
vtkWeakPointerBase ** | WeakPointers

## Additional Inherited Members
Static Protected Member Functions inherited from vtkObjectBase
static vtkMallocingFunction | GetCurrentMallocFunction ()
static vtkReallocingFunction | GetCurrentReallocFunction ()
static vtkFreeingFunction | GetCurrentFreeFunction ()
static vtkFreeingFunction | GetAlternateFreeFunction ()

## Detailed Description

A cell-grid query for enumerating sides of cells.

Compute external faces of a cell-grid.

As responders invoke the AddSides() method on this query, entries are added to storage indicating the number of times a given shape + connectivity appear. After the query is finalized, calling GetSides() will return a map holding sets of sides organized by cell ID for any shape + connectivity repeated an odd number of times.

Definition at line 32 of file vtkCellGridSidesQuery.h.

## Member Typedef Documentation

## ◆ Superclass

typedef vtkCellGridQuery vtkCellGridSidesQuery::Superclass

Definition at line 36 of file vtkCellGridSidesQuery.h.

## Constructor & Destructor Documentation

## ◆ vtkCellGridSidesQuery()

vtkCellGridSidesQuery::vtkCellGridSidesQuery | ( |  | ) |
| protecteddefault

## ◆ ~vtkCellGridSidesQuery()

vtkCellGridSidesQuery::~vtkCellGridSidesQuery | ( |  | ) |
| overrideprotecteddefault

## Member Function Documentation

## ◆ New()

static vtkCellGridSidesQuery* vtkCellGridSidesQuery::New | ( |  | ) |
| static

## ◆ IsTypeOf()

static vtkTypeBool vtkCellGridSidesQuery::IsTypeOf | ( | const char * | type | ) |
| static

## ◆ IsA()

virtual vtkTypeBool vtkCellGridSidesQuery::IsA | ( | const char * | name | ) |
| virtual

Return 1 if this class is the same type of (or a subclass of) the named class.

Returns 0 otherwise. This method works in combination with vtkTypeMacro found in vtkSetGet.h.

Reimplemented from vtkCellGridQuery.

## ◆ SafeDownCast()

static vtkCellGridSidesQuery* vtkCellGridSidesQuery::SafeDownCast | ( | vtkObjectBase * | o | ) |
| static

## ◆ NewInstanceInternal()

virtual vtkObjectBase* vtkCellGridSidesQuery::NewInstanceInternal | ( |  | ) | const
| protectedvirtual

Reimplemented from vtkCellGridQuery.

## ◆ NewInstance()

vtkCellGridSidesQuery* vtkCellGridSidesQuery::NewInstance | ( |  | ) | const

## ◆ PrintSelf()

void vtkCellGridSidesQuery::PrintSelf | ( | ostream & | os,
|  | vtkIndent | indent
| ) |  |
| overridevirtual

Methods invoked by print to print information about the object including superclasses.

Typically not called by the user (use Print() instead) but used in the hierarchical print process to combine the output of several classes.

Reimplemented from vtkCellGridQuery.

## ◆ Initialize()

void vtkCellGridSidesQuery::Initialize | ( |  | ) |
| overridevirtual

Override this if your query-result state requires initialization.

Reimplemented from vtkCellGridQuery.

## ◆ Finalize()

void vtkCellGridSidesQuery::Finalize | ( |  | ) |
| overridevirtual

Override this if your query-result state requires finalization.

Reimplemented from vtkCellGridQuery.

## ◆ GetSides()

std::map<vtkStringToken, std::unordered_map<vtkStringToken, std::unordered_map<vtkIdType, std::set<int> > > >& vtkCellGridSidesQuery::GetSides | ( |  | ) |
| inline

Definition at line 44 of file vtkCellGridSidesQuery.h.

## ◆ AddSide() [1/2]

template<typename T , std::size_t NN>

void vtkCellGridSidesQuery::AddSide | ( | vtkStringToken | cellType,
|  | vtkIdType | cell,
|  | int | side,
|  | vtkStringToken | shape,
|  | const std::array< T, NN > & | conn
| ) |  |
| inline

Add a side with the given shape and connectivity to the request's state.

The shape, conn size, and conn entries are hashed together into a key which is mapped to a set of all the matching sides. The cellType and cell ID are also stored with each matching side; these are used during Finalize() to generate the output map-of-maps returned by GetSides() so that the sides are reported by cell type, cell ID, and then side ID.

Note that the conn entries are hashed in a particular canonical order so that the same hash is generated for sides with point IDs that have been shifted and/or reversed. The hash always starts at the smallest entry of conn and goes in the direction that has the largest next entry. Examples: (3, 2, 0, 1) → starts at index 2 (0) and hashes backwards: (0, 2, 3, 1) (4, 5, 6, 7) → starts at index 0 (4) and hashes backwards: (4, 7, 6, 5) (7, 3, 6, 2) → starts at index 3 (2) and hashes forwards: (2, 7, 3, 6)

By storing the cellType, we avoid requiring a global-to-local cell numbering in vtkCellGrid instances (as vtkPolyData incurs) which may hold multiple types of cells.

Definition at line 73 of file vtkCellGridSidesQuery.h.

## ◆ AddSide() [2/2]

template<typename T >

void vtkCellGridSidesQuery::AddSide | ( | vtkStringToken | cellType,
|  | vtkIdType | cell,
|  | int | side,
|  | vtkStringToken | shape,
|  | const std::vector< T > & | conn
| ) |  |
| inline

Definition at line 112 of file vtkCellGridSidesQuery.h.

## Member Data Documentation

## ◆ Hashes

std::unordered_map<std::size_t, Entry> vtkCellGridSidesQuery::Hashes
| protected

Definition at line 221 of file vtkCellGridSidesQuery.h.

## ◆ Sides

std::map<vtkStringToken, std::unordered_map<vtkStringToken, std::unordered_map<vtkIdType, std::set<int> > > > vtkCellGridSidesQuery::Sides
| protected

Definition at line 224 of file vtkCellGridSidesQuery.h.

The documentation for this class was generated from the following file:

- Common/DataModel/vtkCellGridSidesQuery.h